# TODO: DKU2 kernel module (usb-serial.h missing from kernel-devel)
# TODO: merge patches upstream where applicable

Name:           gnokii
Version:        0.6.12
Release:        4%{?dist}
Summary:        Linux/Unix tool suite for various mobile phones

Group:          Applications/Communications
License:        GPL
URL:            http://www.gnokii.org/
Source0:        http://www.gnokii.org/download/gnokii/%{name}-%{version}.tar.bz2
Source2:        %{name}-smsd.init
Source3:        %{name}-smsd.sysconfig
Source4:        %{name}-smsd.logrotate
Source5:        %{name}-smsd2mail.sh
Source6:        %{name}-smsd-README.smsd2mail
# Patch to make gnokii use "htmlview" instead of "mozilla" as default browser
Patch0:         %{name}-htmlview.patch
# Patch to also guide the user on how to create the smsd database without presupposing 
# it already exists plus a more apropriate index setup.
Patch1:         %{name}-smsd-sql.patch
# Patch to remove port locking and apply the system-wide /usr/sbin directory
# to the path instead of the default /usr/local
Patch2:         %{name}-config.patch
# Patch to rename smdsd to gnokii-smsd (also in doc)
Patch3:         %{name}-smsd-rename.patch
# Patch to fix the superfluous include statements
Patch4:         %{name}-pkgconfig.patch
Patch5:		%{name}-xgnokii-pkgconfig.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  flex
BuildRequires:  gettext
BuildRequires:  gtk2-devel
BuildRequires:  desktop-file-utils
BuildRequires:  ImageMagick
BuildRequires:  postgresql-devel
BuildRequires:  mysql-devel
BuildRequires:  zlib-devel
BuildRequires:  bluez-libs-devel
%{?_with_libical:BuildRequires: libical-devel >= 0.24}
%if "%fedora" >= "5"
BuildRequires:	libXt-devel
BuildRequires:	libXpm-devel 
%else
# openssl-devel: https://bugzilla.redhat.com/159569
BuildRequires:  openssl-devel
%endif
Requires(pre):  %{_sbindir}/groupadd

%description
Gnokii provides tools and a user space driver for use with mobile
phones under Linux, various unices and Win32. With gnokii you can do
such things as make data calls, update your address book, change
calendar entires, send and receive SMS messages and load ring tones
depending on the phone you have.

%package     -n xgnokii
Summary:        Graphical Linux/Unix tool suite for various mobile phones
Group:          Applications/Communications
Requires:       %{name} = %{version}-%{release}

%description -n xgnokii
Xgnokii is graphical Linux/Unix tool suite for various mobile
phones. It allows you to edit your contacts book, send/read SMS's
from/in computer and more other features.

%package        smsd
Summary:        Gnokii SMS daemon
Group:          System Environment/Daemons
Requires:       %{name} = %{version}-%{release}
Requires(pre):  %{_sbindir}/useradd
Requires(post): /sbin/chkconfig
Requires(preun): /sbin/chkconfig

%description    smsd
The Gnokii SMS daemon receives and sends SMS messages.

%package        smsd-pgsql
Summary:        PostgreSQL support for Gnokii SMS daemon
Group:          System Environment/Daemons
Requires:       %{name}-smsd = %{version}-%{release}
Obsoletes:      %{name}-smsd-postgresql < 0.6.4-0.lvn.2

%description    smsd-pgsql
%{summary}.

%package        smsd-mysql
Summary:        MySQL support for Gnokii SMS daemon
Group:          System Environment/Daemons
Requires:       %{name}-smsd = %{version}-%{release}

%description    smsd-mysql
%{summary}.

%package        devel
Summary:        Gnokii development files
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}
Requires:       pkgconfig

%description    devel
%{summary}.


%prep
%setup -q
%patch0 -p0
%patch1 -p1
%patch2 -p0
%patch3 -p0
%patch4 -p0
%patch5 -p0
install -pm 644 %{SOURCE5} smsd2mail.sh
install -pm 644 %{SOURCE6} README.smsd2mail
# Fix up X86_64 library placement issue
%{__sed} -i -e 's|/lib /usr/lib\b|/%{_lib} %{_libdir}|' configure
# Polish default font, cool but ISO8859-2
iconv -f iso8859-2 -t utf8 -o iconv.tmp ChangeLog
mv iconv.tmp ChangeLog
iconv -f iso8859-2 -t utf8 -o iconv.tmp Docs/CREDITS
mv iconv.tmp Docs/CREDITS
iconv -f iso8859-2 -t utf8 -o iconv.tmp Docs/README
mv iconv.tmp Docs/README
iconv -f iso8859-2 -t utf8 -o iconv.tmp COPYRIGHT
mv iconv.tmp COPYRIGHT
iconv -f iso8859-2 -t utf8 -o iconv.tmp smsd/ChangeLog
mv iconv.tmp smsd/ChangeLog
iconv -f iso8859-2 -t utf8 -o iconv.tmp xgnokii/ChangeLog
mv iconv.tmp xgnokii/ChangeLog


%build
%configure --enable-security --disable-rpath --disable-static \
  %{?_with_libical:--with-libical=%{_prefix}}
make # -j X for X > 1 fails as of 0.5.6 - 0.6.7
make %{?_smp_mflags} -C smsd all libpq.la libmysql.la libfile.la


%install
rm -rf $RPM_BUILD_ROOT __docinst

make install install-docs DESTDIR=$RPM_BUILD_ROOT \
  xmandir=%{_mandir}/man1 docdir=/__docinst

mv $RPM_BUILD_ROOT/__docinst .
rm __docinst/{README-MacOSX,README-WIN32,packaging-howto}

make install DESTDIR=$RPM_BUILD_ROOT pkglibdir=%{_libdir}/gnokii-smsd -C smsd \
  DB_LIBS="libfile.la libpq.la libmysql.la"
mv $RPM_BUILD_ROOT%{_sbindir}/{,gnokii-}smsd
mv $RPM_BUILD_ROOT%{_mandir}/man8/{,gnokii-}smsd.8

rm $RPM_BUILD_ROOT%{_libdir}{,/gnokii-smsd}/lib*.la

install -Dpm 644 Docs/sample/gnokiirc $RPM_BUILD_ROOT%{_sysconfdir}/gnokiirc

desktop-file-install \
  --delete-original \
  --vendor fedora \
  --dir $RPM_BUILD_ROOT%{_datadir}/applications \
  --mode 644 \
  --add-category X-Fedora \
  $RPM_BUILD_ROOT%{_datadir}/applications/xgnokii.desktop

install -dm 755 $RPM_BUILD_ROOT%{_datadir}/pixmaps
convert Docs/sample/logo/gnokii.xpm \
  $RPM_BUILD_ROOT%{_datadir}/pixmaps/xgnokii.png
chmod 644 $RPM_BUILD_ROOT%{_datadir}/pixmaps/xgnokii.png

install -Dpm 755 %{SOURCE2} $RPM_BUILD_ROOT%{_initrddir}/gnokii-smsd
install -Dpm 640 %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/gnokii-smsd
install -Dpm 644 %{SOURCE4} \
  $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/gnokii-smsd


%find_lang %{name}


%clean
rm -rf $RPM_BUILD_ROOT


%pre
%{_sbindir}/groupadd -r gnokii >/dev/null 2>&1 || :

%pre smsd
%{_sbindir}/useradd -r -M -d / -g gnokii \
  -s /sbin/nologin -c "Gnokii system user" gnokii >/dev/null 2>&1 || :

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%post smsd
/sbin/chkconfig --add gnokii-smsd

%preun smsd
if [ $1 -eq 0 ] ; then
  %{_initrddir}/gnokii-smsd stop >/dev/null 2>&1 || :
  /sbin/chkconfig --del gnokii-smsd
fi

%postun smsd
if [ $1 -ge 1 ] ; then
  %{_initrddir}/gnokii-smsd try-restart >/dev/null 2>&1 || :
fi


%files -f %{name}.lang
%defattr(-,root,root,-)
%doc ChangeLog COPY* MAINTAINERS TODO VERSION __docinst/*
%config(noreplace) %{_sysconfdir}/gnokiirc
%attr(4750,root,gnokii) %{_sbindir}/mgnokiidev
%{_bindir}/gnokii
%{_bindir}/ppm2nokia
%{_bindir}/sendsms
%{_bindir}/todologo
%{_sbindir}/gnokiid
%{_libdir}/libgnokii.so.*
%{_mandir}/man1/gnokii.1*
%{_mandir}/man1/ppm2nokia.1*
%{_mandir}/man1/sendsms.1*
%{_mandir}/man1/todologo.1*
%{_mandir}/man8/gnokiid.8*
%{_mandir}/man8/mgnokiidev.8*

%files -n xgnokii
%defattr(-,root,root,-)
%doc xgnokii/ChangeLog xgnokii/README.vcard xgnokii/VERSION
%{_bindir}/xgnokii
%{_datadir}/pixmaps/xgnokii.png
%{_datadir}/applications/*xgnokii.desktop
%{_mandir}/man1/xgnokii.1*
%{_prefix}/share/xgnokii/

%files smsd
%defattr(-,root,root,-)
%doc smsd/action smsd/ChangeLog smsd/README README.smsd2mail smsd2mail.sh
%attr(-,gnokii,gnokii) %config(noreplace) %{_sysconfdir}/sysconfig/gnokii-smsd
%config(noreplace) %{_sysconfdir}/logrotate.d/gnokii-smsd
%{_initrddir}/gnokii-smsd
%{_sbindir}/gnokii-smsd
%{_mandir}/man8/gnokii-smsd.8*
%dir %{_libdir}/gnokii-smsd/
%{_libdir}/gnokii-smsd/libfile.so

%files smsd-pgsql
%defattr(-,root,root,-)
%doc smsd/sms.tables.pq.sql
%{_libdir}/gnokii-smsd/libpq.so

%files smsd-mysql
%defattr(-,root,root,-)
%doc smsd/sms.tables.mysql.sql
%{_libdir}/gnokii-smsd/libmysql.so

%files devel
%defattr(-,root,root,-)
%{_includedir}/gnokii*
%{_libdir}/libgnokii.so
%{_libdir}/pkgconfig/gnokii.pc
%{_libdir}/pkgconfig/xgnokii.pc

%changelog
* Sun Apr 2 2006 Linus Walleij <triad@df.lth.se> - 0.6.12-4
- Goofed up. Fixit it...

* Sun Apr 2 2006 Linus Walleij <triad@df.lth.se> - 0.6.12-3
- Post-import updates.

* Thu Mar 31 2006 Linus Walleij <triad@df.lth.se> - 0.6.12-2
- Updated after comments from Ville.

* Thu Mar 16 2006 Linus Walleij <triad@df.lth.se> - 0.6.12-1
- New upstream tarball

* Wed Mar 8 2006 Linus Walleij <triad@df.lth.se> - 0.6.11-2
- Updated after comments from Ville.

* Sun Mar 5 2006 Linus Walleij <triad@df.lth.se> - 0.6.11-1
- 0.6.11
- Modified to drop into the Fedora Extras as the nice package it now is
- Based work off Ville's good olde package

* Sun Nov 13 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.6.10-0.lvn.1
- 0.6.10.
- Clean up pkgconfig file and -devel dependencies from bits needed only
  for static libs.

* Thu Nov  3 2005 Ville Skyttä <ville.skytta at iki.fi> - 0.6.9-0.lvn.1
- 0.6.9, desktop entry file included upstream.
- Drop zero Epochs.

* Sat Aug  6 2005 Ville Skyttä <ville.skytta at iki.fi> - 0:0.6.8-0.lvn.1
- 0.6.8.
- Don't ship static libraries.
- Rename smsd to gnokii-smsd to avoid conflicts with smstools.
- Remove not included files instead of using %%exclude.

* Sat Jun  4 2005 Ville Skyttä <ville.skytta at iki.fi> - 0:0.6.7-0.lvn.2
- BuildRequire openssl-devel to work around https://bugzilla.redhat.com/159569

* Thu Jun  2 2005 Ville Skyttä <ville.skytta at iki.fi> - 0:0.6.7-0.lvn.1
- 0.6.7.
- Build unconditionally with bluetooth support.

* Mon May  2 2005 Ville Skyttä <ville.skytta at iki.fi> - 0:0.6.5-0.lvn.1
- 0.6.5.

* Fri Nov  5 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.6.4-0.lvn.2
- Rename -smsd-postgresql to -smsd-pgsql for consistency with other similar
  packages in FC/Extras.

* Fri Oct 22 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.6.4-0.lvn.1
- Update to 0.6.4, perms and pgsql patches applied upstream.
- Xgnokii help locale symlink hack no longer necessary.
- Don't remove user/group on last erase, move smsd user to -smsd subpackage.
- Add libical support (disabled), rebuild with "--with libical" to enable.

* Mon Jul  5 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.6.3-0.lvn.1
- Update to 0.6.3.

* Sun Jun 20 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.6.1-0.lvn.4
- Improve Xgnokii desktop entry according to GNOME HIG.

* Sun Jun 13 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.6.1-0.lvn.3
- Remove duplicate gettext build dependency (bug 95).

* Sun Jun  6 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.6.1-0.lvn.2
- Fix chown syntax in smsd init script.
- Summary and description improvements.
- Trim $RPM_OPT_FLAGS out from gnokii.pc.
- Make -devel require XFree86-devel.

* Sun Apr 18 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.6.1-0.lvn.1
- Update to 0.6.1.

* Thu Mar 18 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.6.0-0.lvn.2
- Make -devel require pkgconfig.

* Mon Feb 23 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.6.0-0.lvn.1
- Update to 0.6.0.

* Mon Feb  2 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.5.10-0.lvn.1
- Update to 0.5.10.

* Tue Jan 27 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.5.9-0.lvn.1
- Update to 0.5.9.
- Specfile cleanups, small init script enhancements.

* Sat Dec 27 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:0.5.7-0.lvn.1
- Update to 0.5.7.
- Move smsd man page into -smsd subpackage.

* Sat Nov 15 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:0.5.6-0.lvn.1
- Update to 0.5.6.
- Include sample action script for forwarding SMSD messages to mail.
- s/fedora/livna/.
- Specfile and init script cleanups.

* Sat Jul 19 2003 Warren Togami <warren@togami.com> - 0:0.5.2-0.fdr.2
- Disable smp flags to prevent build failure

* Sun Jun 15 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:0.5.2-0.fdr.1
- Update to 0.5.2.

* Thu May 29 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:0.5.1-0.fdr.1
- Update to 0.5.1.
- Include init script, sysconfig and logrotate config for smsd.

* Tue May 27 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:0.5.0-0.fdr.1
- Update to 0.5.0.

* Sun Nov  3 2002 Ville Skyttä <ville.skytta at iki.fi> 0.4.3-1cr
- RedHat'ified PLD version.
